\name{train_glasso}
\alias{train_glasso}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Group LASSO for Sequence Data}
\description{Training group LASSO for FASTA data based on the grplasso package. The regularization parameter is automatically selected by 10-fold CV.}
\usage{train_glasso(fasta_file, wavelength_file, pos_file = NULL)}
%- maybe also 'usage' for other objects documented here.
\arguments{
\item{fasta_file}{the name of the FASTA file which contains a set of aligned sequences. The file is read by "read.fasta" function of the R "seqinr" package.
}
\item{wavelength_file}{
  the name of the text file in which each line contains a wavelength for a sequence. The order of the sequences in the FASTA le and the wavelength file should be consistent. For wavelength unknown sequences, please specify "NA" in the wavelength file. Proteins specied as "NA" are regarded as target proteins, and other proteins with wavelengths are used as training proteins.
}
\item{pos_file}{
  (optional) the name of the text file containing positions. Instead of using all residues, a subset of positions in the aligned sequence can be specied to focus on some region of interest in the sequences.  The positions should be written in the text file in which each line contains a position index.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
\item{model}{output of the function 'grplasso' (see help of grplasso for detail).}
\item{position}{positions in the sequence (if specified).}
\item{predicted_wavelen}{predicted wavelength for test data.}
\item{test_idx}{index of test data.}
\item{removed_feat}{index of removed features. Binary features corresponding to "gap" (-), "translation stop" (*), and "any" (x) are removed.}
}
\references{
%% ~put references to the literature/web site here ~
}
\author{
%%  ~~who you are~~
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
#
# Specify the file names of FASTA, wavelength, and position as
# "fasta_file", "wave_file", "pos_file" 
#

# Learning group LASSO
result <- train_glasso(fasta_file, wave_file, pos_file);

# Prediction
f <- predict_wavelen(result,fasta_file);
}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
